// Compiled by ClojureScript 0.0-2138
goog.provide('lt.object');
goog.require('cljs.core');
goog.require('lt.util.dom');
goog.require('lt.util.js');
goog.require('crate.binding');
goog.require('lt.util.js');
goog.require('lt.util.dom');
goog.require('lt.util.cljs');
goog.require('crate.core');
goog.require('lt.util.dom');
goog.require('clojure.string');
goog.require('lt.util.cljs');
goog.require('clojure.set');
goog.require('clojure.string');
goog.require('crate.binding');
goog.require('clojure.set');
goog.require('crate.core');
/**
* Counter to guarantee unique object ids
*/
lt.object.obj_id = cljs.core.atom.call(null,0);
/**
* Map of object ids to objects created by object/create
*/
lt.object.instances = cljs.core.atom.call(null,cljs.core.sorted_map.call(null));
/**
* Map of behavior names to behaviors created by macros/behavior
*/
lt.object.behaviors = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
/**
* Map of object template keys to template maps created by object/object*
*/
lt.object.object_defs = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
/**
* Map of tags to associated lists of behaviors
*/
lt.object.tags = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
/**
* Map of tags to dissociated lists of behaviors e.g. :-behavior
*/
lt.object.negated_tags = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
/**
* Metadata of current behavior set during raise and raise-reduce
*/
lt.object._STAR_behavior_meta_STAR_ = null;
lt.object.add = (function add(obj){return cljs.core.swap_BANG_.call(null,lt.object.object_defs,cljs.core.assoc,new cljs.core.Keyword("lt.object","type","lt.object/type",701613666).cljs$core$IFn$_invoke$arity$1(obj),obj);
});
lt.object.add_behavior = (function add_behavior(beh){return cljs.core.swap_BANG_.call(null,lt.object.behaviors,cljs.core.assoc,new cljs.core.Keyword(null,"name","name",1017277949).cljs$core$IFn$_invoke$arity$1(beh),beh);
});
/**
* Return id of given object
*/
lt.object.__GT_id = (function __GT_id(obj){if(crate.binding.deref_QMARK_.call(null,obj))
{return new cljs.core.Keyword("lt.object","id","lt.object/id",706431105).cljs$core$IFn$_invoke$arity$1(cljs.core.deref.call(null,obj));
} else
{return new cljs.core.Keyword("lt.object","id","lt.object/id",706431105).cljs$core$IFn$_invoke$arity$1(obj);
}
});
lt.object.__GT_behavior_name = (function __GT_behavior_name(beh){if(cljs.core.coll_QMARK_.call(null,beh))
{return cljs.core.first.call(null,beh);
} else
{return beh;
}
});
lt.object.__GT_behavior = (function __GT_behavior(beh){return cljs.core.deref.call(null,lt.object.behaviors).call(null,lt.object.__GT_behavior_name.call(null,beh));
});
lt.object.__GT_triggers = (function __GT_triggers(behs){var result = cljs.core.atom.call(null,cljs.core.transient$.call(null,cljs.core.PersistentArrayMap.EMPTY));var seq__14220_14232 = cljs.core.seq.call(null,behs);var chunk__14225_14233 = null;var count__14226_14234 = 0;var i__14227_14235 = 0;while(true){
if((i__14227_14235 < count__14226_14234))
{var beh_14236 = cljs.core._nth.call(null,chunk__14225_14233,i__14227_14235);var seq__14228_14237 = cljs.core.seq.call(null,new cljs.core.Keyword(null,"triggers","triggers",2516997421).cljs$core$IFn$_invoke$arity$1(lt.object.__GT_behavior.call(null,beh_14236)));var chunk__14229_14238 = null;var count__14230_14239 = 0;var i__14231_14240 = 0;while(true){
if((i__14231_14240 < count__14230_14239))
{var t_14241 = cljs.core._nth.call(null,chunk__14229_14238,i__14231_14240);cljs.core.swap_BANG_.call(null,result,cljs.core.assoc_BANG_,t_14241,cljs.core.conj.call(null,(function (){var or__3520__auto__ = cljs.core.get.call(null,cljs.core.deref.call(null,result),t_14241);if(cljs.core.truth_(or__3520__auto__))
{return or__3520__auto__;
} else
{return cljs.core.PersistentVector.EMPTY;
}
})(),beh_14236));
{
var G__14242 = seq__14228_14237;
var G__14243 = chunk__14229_14238;
var G__14244 = count__14230_14239;
var G__14245 = (i__14231_14240 + 1);
seq__14228_14237 = G__14242;
chunk__14229_14238 = G__14243;
count__14230_14239 = G__14244;
i__14231_14240 = G__14245;
continue;
}
} else
{var temp__4092__auto___14246 = cljs.core.seq.call(null,seq__14228_14237);if(temp__4092__auto___14246)
{var seq__14228_14247__$1 = temp__4092__auto___14246;if(cljs.core.chunked_seq_QMARK_.call(null,seq__14228_14247__$1))
{var c__4262__auto___14248 = cljs.core.chunk_first.call(null,seq__14228_14247__$1);{
var G__14249 = cljs.core.chunk_rest.call(null,seq__14228_14247__$1);
var G__14250 = c__4262__auto___14248;
var G__14251 = cljs.core.count.call(null,c__4262__auto___14248);
var G__14252 = 0;
seq__14228_14237 = G__14249;
chunk__14229_14238 = G__14250;
count__14230_14239 = G__14251;
i__14231_14240 = G__14252;
continue;
}
} else
{var t_14253 = cljs.core.first.call(null,seq__14228_14247__$1);cljs.core.swap_BANG_.call(null,result,cljs.core.assoc_BANG_,t_14253,cljs.core.conj.call(null,(function (){var or__3520__auto__ = cljs.core.get.call(null,cljs.core.deref.call(null,result),t_14253);if(cljs.core.truth_(or__3520__auto__))
{return or__3520__auto__;
} else
{return cljs.core.PersistentVector.EMPTY;
}
})(),beh_14236));
{
var G__14254 = cljs.core.next.call(null,seq__14228_14247__$1);
var G__14255 = null;
var G__14256 = 0;
var G__14257 = 0;
seq__14228_14237 = G__14254;
chunk__14229_14238 = G__14255;
count__14230_14239 = G__14256;
i__14231_14240 = G__14257;
continue;
}
}
} else
{}
}
break;
}
{
var G__14258 = seq__14220_14232;
var G__14259 = chunk__14225_14233;
var G__14260 = count__14226_14234;
var G__14261 = (i__14227_14235 + 1);
seq__14220_14232 = G__14258;
chunk__14225_14233 = G__14259;
count__14226_14234 = G__14260;
i__14227_14235 = G__14261;
continue;
}
} else
{var temp__4092__auto___14262 = cljs.core.seq.call(null,seq__14220_14232);if(temp__4092__auto___14262)
{var seq__14220_14263__$1 = temp__4092__auto___14262;if(cljs.core.chunked_seq_QMARK_.call(null,seq__14220_14263__$1))
{var c__4262__auto___14264 = cljs.core.chunk_first.call(null,seq__14220_14263__$1);{
var G__14265 = cljs.core.chunk_rest.call(null,seq__14220_14263__$1);
var G__14266 = c__4262__auto___14264;
var G__14267 = cljs.core.count.call(null,c__4262__auto___14264);
var G__14268 = 0;
seq__14220_14232 = G__14265;
chunk__14225_14233 = G__14266;
count__14226_14234 = G__14267;
i__14227_14235 = G__14268;
continue;
}
} else
{var beh_14269 = cljs.core.first.call(null,seq__14220_14263__$1);var seq__14221_14270 = cljs.core.seq.call(null,new cljs.core.Keyword(null,"triggers","triggers",2516997421).cljs$core$IFn$_invoke$arity$1(lt.object.__GT_behavior.call(null,beh_14269)));var chunk__14222_14271 = null;var count__14223_14272 = 0;var i__14224_14273 = 0;while(true){
if((i__14224_14273 < count__14223_14272))
{var t_14274 = cljs.core._nth.call(null,chunk__14222_14271,i__14224_14273);cljs.core.swap_BANG_.call(null,result,cljs.core.assoc_BANG_,t_14274,cljs.core.conj.call(null,(function (){var or__3520__auto__ = cljs.core.get.call(null,cljs.core.deref.call(null,result),t_14274);if(cljs.core.truth_(or__3520__auto__))
{return or__3520__auto__;
} else
{return cljs.core.PersistentVector.EMPTY;
}
})(),beh_14269));
{
var G__14275 = seq__14221_14270;
var G__14276 = chunk__14222_14271;
var G__14277 = count__14223_14272;
var G__14278 = (i__14224_14273 + 1);
seq__14221_14270 = G__14275;
chunk__14222_14271 = G__14276;
count__14223_14272 = G__14277;
i__14224_14273 = G__14278;
continue;
}
} else
{var temp__4092__auto___14279__$1 = cljs.core.seq.call(null,seq__14221_14270);if(temp__4092__auto___14279__$1)
{var seq__14221_14280__$1 = temp__4092__auto___14279__$1;if(cljs.core.chunked_seq_QMARK_.call(null,seq__14221_14280__$1))
{var c__4262__auto___14281 = cljs.core.chunk_first.call(null,seq__14221_14280__$1);{
var G__14282 = cljs.core.chunk_rest.call(null,seq__14221_14280__$1);
var G__14283 = c__4262__auto___14281;
var G__14284 = cljs.core.count.call(null,c__4262__auto___14281);
var G__14285 = 0;
seq__14221_14270 = G__14282;
chunk__14222_14271 = G__14283;
count__14223_14272 = G__14284;
i__14224_14273 = G__14285;
continue;
}
} else
{var t_14286 = cljs.core.first.call(null,seq__14221_14280__$1);cljs.core.swap_BANG_.call(null,result,cljs.core.assoc_BANG_,t_14286,cljs.core.conj.call(null,(function (){var or__3520__auto__ = cljs.core.get.call(null,cljs.core.deref.call(null,result),t_14286);if(cljs.core.truth_(or__3520__auto__))
{return or__3520__auto__;
} else
{return cljs.core.PersistentVector.EMPTY;
}
})(),beh_14269));
{
var G__14287 = cljs.core.next.call(null,seq__14221_14280__$1);
var G__14288 = null;
var G__14289 = 0;
var G__14290 = 0;
seq__14221_14270 = G__14287;
chunk__14222_14271 = G__14288;
count__14223_14272 = G__14289;
i__14224_14273 = G__14290;
continue;
}
}
} else
{}
}
break;
}
{
var G__14291 = cljs.core.next.call(null,seq__14220_14263__$1);
var G__14292 = null;
var G__14293 = 0;
var G__14294 = 0;
seq__14220_14232 = G__14291;
chunk__14225_14233 = G__14292;
count__14226_14234 = G__14293;
i__14227_14235 = G__14294;
continue;
}
}
} else
{}
}
break;
}
return cljs.core.persistent_BANG_.call(null,cljs.core.deref.call(null,result));
});
lt.object.specificity_sort = (function() {
var specificity_sort = null;
var specificity_sort__1 = (function (xs){return specificity_sort.call(null,xs,null);
});
var specificity_sort__2 = (function (xs,dir){var arr = [];var seq__14299_14303 = cljs.core.seq.call(null,xs);var chunk__14300_14304 = null;var count__14301_14305 = 0;var i__14302_14306 = 0;while(true){
if((i__14302_14306 < count__14301_14305))
{var x_14307 = cljs.core._nth.call(null,chunk__14300_14304,i__14302_14306);arr.push([[cljs.core.str(x_14307)].join('').split(".").length,[cljs.core.str(x_14307)].join(''),x_14307]);
{
var G__14308 = seq__14299_14303;
var G__14309 = chunk__14300_14304;
var G__14310 = count__14301_14305;
var G__14311 = (i__14302_14306 + 1);
seq__14299_14303 = G__14308;
chunk__14300_14304 = G__14309;
count__14301_14305 = G__14310;
i__14302_14306 = G__14311;
continue;
}
} else
{var temp__4092__auto___14312 = cljs.core.seq.call(null,seq__14299_14303);if(temp__4092__auto___14312)
{var seq__14299_14313__$1 = temp__4092__auto___14312;if(cljs.core.chunked_seq_QMARK_.call(null,seq__14299_14313__$1))
{var c__4262__auto___14314 = cljs.core.chunk_first.call(null,seq__14299_14313__$1);{
var G__14315 = cljs.core.chunk_rest.call(null,seq__14299_14313__$1);
var G__14316 = c__4262__auto___14314;
var G__14317 = cljs.core.count.call(null,c__4262__auto___14314);
var G__14318 = 0;
seq__14299_14303 = G__14315;
chunk__14300_14304 = G__14316;
count__14301_14305 = G__14317;
i__14302_14306 = G__14318;
continue;
}
} else
{var x_14319 = cljs.core.first.call(null,seq__14299_14313__$1);arr.push([[cljs.core.str(x_14319)].join('').split(".").length,[cljs.core.str(x_14319)].join(''),x_14319]);
{
var G__14320 = cljs.core.next.call(null,seq__14299_14313__$1);
var G__14321 = null;
var G__14322 = 0;
var G__14323 = 0;
seq__14299_14303 = G__14320;
chunk__14300_14304 = G__14321;
count__14301_14305 = G__14322;
i__14302_14306 = G__14323;
continue;
}
}
} else
{}
}
break;
}
arr.sort();
if(cljs.core.truth_(dir))
{} else
{arr.reverse();
}
var arr__3409__auto___14324 = arr;var i_14325 = 0;while(true){
if((i_14325 < arr__3409__auto___14324.length))
{(arr[i_14325] = (arr[i_14325][2]));
{
var G__14326 = (i_14325 + 1);
i_14325 = G__14326;
continue;
}
} else
{}
break;
}
return arr;
});
specificity_sort = function(xs,dir){
switch(arguments.length){
case 1:
return specificity_sort__1.call(this,xs);
case 2:
return specificity_sort__2.call(this,xs,dir);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
specificity_sort.cljs$core$IFn$_invoke$arity$1 = specificity_sort__1;
specificity_sort.cljs$core$IFn$_invoke$arity$2 = specificity_sort__2;
return specificity_sort;
})()
;
lt.object.ts__GT_negations = (function ts__GT_negations(ts){var seen = (function (){var obj14334 = {};return obj14334;
})();var seq__14335_14339 = cljs.core.seq.call(null,cljs.core.apply.call(null,cljs.core.concat,cljs.core.map.call(null,cljs.core.deref.call(null,lt.object.negated_tags),ts)));var chunk__14336_14340 = null;var count__14337_14341 = 0;var i__14338_14342 = 0;while(true){
if((i__14338_14342 < count__14337_14341))
{var beh_14343 = cljs.core._nth.call(null,chunk__14336_14340,i__14338_14342);(seen[lt.object.__GT_behavior_name.call(null,beh_14343)] = true);
{
var G__14344 = seq__14335_14339;
var G__14345 = chunk__14336_14340;
var G__14346 = count__14337_14341;
var G__14347 = (i__14338_14342 + 1);
seq__14335_14339 = G__14344;
chunk__14336_14340 = G__14345;
count__14337_14341 = G__14346;
i__14338_14342 = G__14347;
continue;
}
} else
{var temp__4092__auto___14348 = cljs.core.seq.call(null,seq__14335_14339);if(temp__4092__auto___14348)
{var seq__14335_14349__$1 = temp__4092__auto___14348;if(cljs.core.chunked_seq_QMARK_.call(null,seq__14335_14349__$1))
{var c__4262__auto___14350 = cljs.core.chunk_first.call(null,seq__14335_14349__$1);{
var G__14351 = cljs.core.chunk_rest.call(null,seq__14335_14349__$1);
var G__14352 = c__4262__auto___14350;
var G__14353 = cljs.core.count.call(null,c__4262__auto___14350);
var G__14354 = 0;
seq__14335_14339 = G__14351;
chunk__14336_14340 = G__14352;
count__14337_14341 = G__14353;
i__14338_14342 = G__14354;
continue;
}
} else
{var beh_14355 = cljs.core.first.call(null,seq__14335_14349__$1);(seen[lt.object.__GT_behavior_name.call(null,beh_14355)] = true);
{
var G__14356 = cljs.core.next.call(null,seq__14335_14349__$1);
var G__14357 = null;
var G__14358 = 0;
var G__14359 = 0;
seq__14335_14339 = G__14356;
chunk__14336_14340 = G__14357;
count__14337_14341 = G__14358;
i__14338_14342 = G__14359;
continue;
}
}
} else
{}
}
break;
}
return seen;
});
lt.object.tags__GT_behaviors = (function tags__GT_behaviors(ts){var duped = cljs.core.apply.call(null,cljs.core.concat,cljs.core.map.call(null,cljs.core.deref.call(null,lt.object.tags),lt.object.specificity_sort.call(null,ts)));var de_duped = cljs.core.reduce.call(null,((function (duped){
return (function (res,cur){if(cljs.core.truth_((new cljs.core.Keyword(null,"seen","seen",1017430509).cljs$core$IFn$_invoke$arity$1(res)[lt.object.__GT_behavior_name.call(null,cur)])))
{return res;
} else
{var beh = lt.object.__GT_behavior.call(null,cur);if(cljs.core.truth_(new cljs.core.Keyword(null,"exclusive","exclusive",2700522000).cljs$core$IFn$_invoke$arity$1(beh)))
{if(cljs.core.coll_QMARK_.call(null,new cljs.core.Keyword(null,"exclusive","exclusive",2700522000).cljs$core$IFn$_invoke$arity$1(beh)))
{var seq__14364_14368 = cljs.core.seq.call(null,new cljs.core.Keyword(null,"exclusive","exclusive",2700522000).cljs$core$IFn$_invoke$arity$1(beh));var chunk__14365_14369 = null;var count__14366_14370 = 0;var i__14367_14371 = 0;while(true){
if((i__14367_14371 < count__14366_14370))
{var exclude_14372 = cljs.core._nth.call(null,chunk__14365_14369,i__14367_14371);(new cljs.core.Keyword(null,"seen","seen",1017430509).cljs$core$IFn$_invoke$arity$1(res)[exclude_14372] = true);
{
var G__14373 = seq__14364_14368;
var G__14374 = chunk__14365_14369;
var G__14375 = count__14366_14370;
var G__14376 = (i__14367_14371 + 1);
seq__14364_14368 = G__14373;
chunk__14365_14369 = G__14374;
count__14366_14370 = G__14375;
i__14367_14371 = G__14376;
continue;
}
} else
{var temp__4092__auto___14377 = cljs.core.seq.call(null,seq__14364_14368);if(temp__4092__auto___14377)
{var seq__14364_14378__$1 = temp__4092__auto___14377;if(cljs.core.chunked_seq_QMARK_.call(null,seq__14364_14378__$1))
{var c__4262__auto___14379 = cljs.core.chunk_first.call(null,seq__14364_14378__$1);{
var G__14380 = cljs.core.chunk_rest.call(null,seq__14364_14378__$1);
var G__14381 = c__4262__auto___14379;
var G__14382 = cljs.core.count.call(null,c__4262__auto___14379);
var G__14383 = 0;
seq__14364_14368 = G__14380;
chunk__14365_14369 = G__14381;
count__14366_14370 = G__14382;
i__14367_14371 = G__14383;
continue;
}
} else
{var exclude_14384 = cljs.core.first.call(null,seq__14364_14378__$1);(new cljs.core.Keyword(null,"seen","seen",1017430509).cljs$core$IFn$_invoke$arity$1(res)[exclude_14384] = true);
{
var G__14385 = cljs.core.next.call(null,seq__14364_14378__$1);
var G__14386 = null;
var G__14387 = 0;
var G__14388 = 0;
seq__14364_14368 = G__14385;
chunk__14365_14369 = G__14386;
count__14366_14370 = G__14387;
i__14367_14371 = G__14388;
continue;
}
}
} else
{}
}
break;
}
} else
{}
(new cljs.core.Keyword(null,"seen","seen",1017430509).cljs$core$IFn$_invoke$arity$1(res)[lt.object.__GT_behavior_name.call(null,cur)] = true);
} else
{}
cljs.core.conj_BANG_.call(null,new cljs.core.Keyword(null,"final","final",1111340264).cljs$core$IFn$_invoke$arity$1(res),cur);
return res;
}
});})(duped))
,new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"seen","seen",1017430509),lt.object.ts__GT_negations.call(null,ts),new cljs.core.Keyword(null,"final","final",1111340264),cljs.core.transient$.call(null,cljs.core.PersistentVector.EMPTY)], null),duped);return cljs.core.reverse.call(null,cljs.core.persistent_BANG_.call(null,new cljs.core.Keyword(null,"final","final",1111340264).cljs$core$IFn$_invoke$arity$1(de_duped)));
});
lt.object.trigger__GT_behaviors = (function trigger__GT_behaviors(trig,ts){return cljs.core.get.call(null,lt.object.__GT_triggers.call(null,lt.object.tags__GT_behaviors.call(null,ts)),trig);
});
lt.object.safe_report_error = (function safe_report_error(e){if(cljs.core.truth_(lt.objs.console))
{return lt.objs.console.error(e);
} else
{return console.error(((typeof e === 'string')?e:e.stack));
}
});
lt.object.raise_STAR_ = (function() {
var raise_STAR_ = null;
var raise_STAR___3 = (function (obj,reactions,args){return raise_STAR_.call(null,obj,reactions,args,null);
});
var raise_STAR___4 = (function (obj,reactions,args,trigger){var seq__14403 = cljs.core.seq.call(null,reactions);var chunk__14406 = null;var count__14407 = 0;var i__14408 = 0;while(true){
if((i__14408 < count__14407))
{var r = cljs.core._nth.call(null,chunk__14406,i__14408);var func = new cljs.core.Keyword(null,"reaction","reaction",4441361819).cljs$core$IFn$_invoke$arity$1(lt.object.__GT_behavior.call(null,r));var args__$1 = ((cljs.core.coll_QMARK_.call(null,r))?cljs.core.concat.call(null,cljs.core.rest.call(null,r),args):args);var meta = ((cljs.core.coll_QMARK_.call(null,r))?cljs.core.meta.call(null,r):cljs.core.PersistentArrayMap.EMPTY);if(cljs.core.truth_(func))
{try{var start14412_14417 = (new Date()).getTime();var _STAR_behavior_meta_STAR_14413_14418 = lt.object._STAR_behavior_meta_STAR_;try{lt.object._STAR_behavior_meta_STAR_ = meta;
cljs.core.apply.call(null,func,obj,args__$1);
}finally {lt.object._STAR_behavior_meta_STAR_ = _STAR_behavior_meta_STAR_14413_14418;
}if(cljs.core._EQ_.call(null,trigger,new cljs.core.Keyword(null,"object.behavior.time","object.behavior.time",854340588)))
{} else
{lt.object.raise.call(null,obj,new cljs.core.Keyword(null,"object.behavior.time","object.behavior.time",854340588),r,((new Date()).getTime() - start14412_14417),trigger);
}
}catch (e14411){if((e14411 instanceof Error))
{var e_14419 = e14411;lt.object.safe_report_error.call(null,[cljs.core.str("Invalid behavior: "),cljs.core.str(new cljs.core.Keyword(null,"name","name",1017277949).cljs$core$IFn$_invoke$arity$1(lt.object.__GT_behavior.call(null,r)))].join(''));
lt.object.safe_report_error.call(null,e_14419);
} else
{if((e14411 instanceof global.Error))
{var e_14420 = e14411;lt.object.safe_report_error.call(null,[cljs.core.str("Invalid behavior: "),cljs.core.str(new cljs.core.Keyword(null,"name","name",1017277949).cljs$core$IFn$_invoke$arity$1(lt.object.__GT_behavior.call(null,r)))].join(''));
lt.object.safe_report_error.call(null,e_14420);
} else
{if(new cljs.core.Keyword(null,"else","else",1017020587))
{throw e14411;
} else
{}
}
}
}{
var G__14421 = seq__14403;
var G__14422 = chunk__14406;
var G__14423 = count__14407;
var G__14424 = (i__14408 + 1);
seq__14403 = G__14421;
chunk__14406 = G__14422;
count__14407 = G__14423;
i__14408 = G__14424;
continue;
}
} else
{{
var G__14425 = seq__14403;
var G__14426 = chunk__14406;
var G__14427 = count__14407;
var G__14428 = (i__14408 + 1);
seq__14403 = G__14425;
chunk__14406 = G__14426;
count__14407 = G__14427;
i__14408 = G__14428;
continue;
}
}
} else
{var temp__4092__auto__ = cljs.core.seq.call(null,seq__14403);if(temp__4092__auto__)
{var seq__14403__$1 = temp__4092__auto__;if(cljs.core.chunked_seq_QMARK_.call(null,seq__14403__$1))
{var c__4262__auto__ = cljs.core.chunk_first.call(null,seq__14403__$1);{
var G__14429 = cljs.core.chunk_rest.call(null,seq__14403__$1);
var G__14430 = c__4262__auto__;
var G__14431 = cljs.core.count.call(null,c__4262__auto__);
var G__14432 = 0;
seq__14403 = G__14429;
chunk__14406 = G__14430;
count__14407 = G__14431;
i__14408 = G__14432;
continue;
}
} else
{var r = cljs.core.first.call(null,seq__14403__$1);var func = new cljs.core.Keyword(null,"reaction","reaction",4441361819).cljs$core$IFn$_invoke$arity$1(lt.object.__GT_behavior.call(null,r));var args__$1 = ((cljs.core.coll_QMARK_.call(null,r))?cljs.core.concat.call(null,cljs.core.rest.call(null,r),args):args);var meta = ((cljs.core.coll_QMARK_.call(null,r))?cljs.core.meta.call(null,r):cljs.core.PersistentArrayMap.EMPTY);if(cljs.core.truth_(func))
{try{var start14415_14433 = (new Date()).getTime();var _STAR_behavior_meta_STAR_14416_14434 = lt.object._STAR_behavior_meta_STAR_;try{lt.object._STAR_behavior_meta_STAR_ = meta;
cljs.core.apply.call(null,func,obj,args__$1);
}finally {lt.object._STAR_behavior_meta_STAR_ = _STAR_behavior_meta_STAR_14416_14434;
}if(cljs.core._EQ_.call(null,trigger,new cljs.core.Keyword(null,"object.behavior.time","object.behavior.time",854340588)))
{} else
{lt.object.raise.call(null,obj,new cljs.core.Keyword(null,"object.behavior.time","object.behavior.time",854340588),r,((new Date()).getTime() - start14415_14433),trigger);
}
}catch (e14414){if((e14414 instanceof Error))
{var e_14435 = e14414;lt.object.safe_report_error.call(null,[cljs.core.str("Invalid behavior: "),cljs.core.str(new cljs.core.Keyword(null,"name","name",1017277949).cljs$core$IFn$_invoke$arity$1(lt.object.__GT_behavior.call(null,r)))].join(''));
lt.object.safe_report_error.call(null,e_14435);
} else
{if((e14414 instanceof global.Error))
{var e_14436 = e14414;lt.object.safe_report_error.call(null,[cljs.core.str("Invalid behavior: "),cljs.core.str(new cljs.core.Keyword(null,"name","name",1017277949).cljs$core$IFn$_invoke$arity$1(lt.object.__GT_behavior.call(null,r)))].join(''));
lt.object.safe_report_error.call(null,e_14436);
} else
{if(new cljs.core.Keyword(null,"else","else",1017020587))
{throw e14414;
} else
{}
}
}
}{
var G__14437 = cljs.core.next.call(null,seq__14403__$1);
var G__14438 = null;
var G__14439 = 0;
var G__14440 = 0;
seq__14403 = G__14437;
chunk__14406 = G__14438;
count__14407 = G__14439;
i__14408 = G__14440;
continue;
}
} else
{{
var G__14441 = cljs.core.next.call(null,seq__14403__$1);
var G__14442 = null;
var G__14443 = 0;
var G__14444 = 0;
seq__14403 = G__14441;
chunk__14406 = G__14442;
count__14407 = G__14443;
i__14408 = G__14444;
continue;
}
}
}
} else
{return null;
}
}
break;
}
});
raise_STAR_ = function(obj,reactions,args,trigger){
switch(arguments.length){
case 3:
return raise_STAR___3.call(this,obj,reactions,args);
case 4:
return raise_STAR___4.call(this,obj,reactions,args,trigger);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
raise_STAR_.cljs$core$IFn$_invoke$arity$3 = raise_STAR___3;
raise_STAR_.cljs$core$IFn$_invoke$arity$4 = raise_STAR___4;
return raise_STAR_;
})()
;
/**
* Invoke object's behavior fns for given trigger. Args are passed to behavior fns
* @param {...*} var_args
*/
lt.object.raise = (function() { 
var raise__delegate = function (obj,k,args){var reactions = k.call(null,new cljs.core.Keyword(null,"listeners","listeners",4090152369).cljs$core$IFn$_invoke$arity$1(cljs.core.deref.call(null,obj)));return lt.object.raise_STAR_.call(null,obj,reactions,args,k);
};
var raise = function (obj,k,var_args){
var args = null;if (arguments.length > 2) {
  args = cljs.core.array_seq(Array.prototype.slice.call(arguments, 2),0);} 
return raise__delegate.call(this,obj,k,args);};
raise.cljs$lang$maxFixedArity = 2;
raise.cljs$lang$applyTo = (function (arglist__14445){
var obj = cljs.core.first(arglist__14445);
arglist__14445 = cljs.core.next(arglist__14445);
var k = cljs.core.first(arglist__14445);
var args = cljs.core.rest(arglist__14445);
return raise__delegate(obj,k,args);
});
raise.cljs$core$IFn$_invoke$arity$variadic = raise__delegate;
return raise;
})()
;
/**
* For a given behavior keyword id, call its :reaction fn with given args
* @param {...*} var_args
*/
lt.object.call_behavior_reaction = (function() { 
var call_behavior_reaction__delegate = function (id,args){var behavior_fn = new cljs.core.Keyword(null,"reaction","reaction",4441361819).cljs$core$IFn$_invoke$arity$1(lt.object.__GT_behavior.call(null,id));if(cljs.core.truth_(behavior_fn))
{} else
{throw (new Error([cljs.core.str("Assert failed: "),cljs.core.str(cljs.core.pr_str.call(null,new cljs.core.Symbol(null,"behavior-fn","behavior-fn",-1300659236,null)))].join('')));
}
return cljs.core.apply.call(null,behavior_fn,args);
};
var call_behavior_reaction = function (id,var_args){
var args = null;if (arguments.length > 1) {
  args = cljs.core.array_seq(Array.prototype.slice.call(arguments, 1),0);} 
return call_behavior_reaction__delegate.call(this,id,args);};
call_behavior_reaction.cljs$lang$maxFixedArity = 1;
call_behavior_reaction.cljs$lang$applyTo = (function (arglist__14446){
var id = cljs.core.first(arglist__14446);
var args = cljs.core.rest(arglist__14446);
return call_behavior_reaction__delegate(id,args);
});
call_behavior_reaction.cljs$core$IFn$_invoke$arity$variadic = call_behavior_reaction__delegate;
return call_behavior_reaction;
})()
;
lt.object.update_listeners = (function() {
var update_listeners = null;
var update_listeners__1 = (function (obj){return update_listeners.call(null,obj,null);
});
var update_listeners__2 = (function (obj,instants){var cur = cljs.core.deref.call(null,obj);var behs = cljs.core.set.call(null,cljs.core.concat.call(null,new cljs.core.Keyword(null,"behaviors","behaviors",607554515).cljs$core$IFn$_invoke$arity$1(cur),lt.object.tags__GT_behaviors.call(null,new cljs.core.Keyword(null,"tags","tags",1017456523).cljs$core$IFn$_invoke$arity$1(cur))));var trigs = lt.object.__GT_triggers.call(null,behs);var trigs__$1 = (cljs.core.truth_(new cljs.core.Keyword(null,"object.instant-load","object.instant-load",4025433875).cljs$core$IFn$_invoke$arity$1(trigs))?(function (){lt.object.raise_STAR_.call(null,obj,new cljs.core.Keyword(null,"object.instant-load","object.instant-load",4025433875).cljs$core$IFn$_invoke$arity$1(trigs),null,new cljs.core.Keyword(null,"object.instant-load","object.instant-load",4025433875));
return lt.object.__GT_triggers.call(null,behs);
})():trigs);var trigs__$2 = (cljs.core.truth_(instants)?trigs__$1:cljs.core.dissoc.call(null,trigs__$1,new cljs.core.Keyword(null,"object.instant","object.instant",773332388),new cljs.core.Keyword(null,"object.instant-load","object.instant-load",4025433875)));return cljs.core.assoc.call(null,cljs.core.deref.call(null,obj),new cljs.core.Keyword(null,"listeners","listeners",4090152369),trigs__$2);
});
update_listeners = function(obj,instants){
switch(arguments.length){
case 1:
return update_listeners__1.call(this,obj);
case 2:
return update_listeners__2.call(this,obj,instants);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
update_listeners.cljs$core$IFn$_invoke$arity$1 = update_listeners__1;
update_listeners.cljs$core$IFn$_invoke$arity$2 = update_listeners__2;
return update_listeners;
})()
;
/**
* @param {...*} var_args
*/
lt.object.make_object_STAR_ = (function() { 
var make_object_STAR___delegate = function (name,r){var obj = cljs.core.merge.call(null,new cljs.core.PersistentArrayMap(null, 6, [new cljs.core.Keyword(null,"behaviors","behaviors",607554515),cljs.core.PersistentHashSet.EMPTY,new cljs.core.Keyword(null,"tags","tags",1017456523),cljs.core.PersistentHashSet.EMPTY,new cljs.core.Keyword(null,"triggers","triggers",2516997421),cljs.core.PersistentVector.EMPTY,new cljs.core.Keyword(null,"listeners","listeners",4090152369),cljs.core.PersistentArrayMap.EMPTY,new cljs.core.Keyword("lt.object","type","lt.object/type",701613666),name,new cljs.core.Keyword(null,"children","children",2673430897),cljs.core.PersistentArrayMap.EMPTY], null),cljs.core.apply.call(null,cljs.core.hash_map,r));return obj;
};
var make_object_STAR_ = function (name,var_args){
var r = null;if (arguments.length > 1) {
  r = cljs.core.array_seq(Array.prototype.slice.call(arguments, 1),0);} 
return make_object_STAR___delegate.call(this,name,r);};
make_object_STAR_.cljs$lang$maxFixedArity = 1;
make_object_STAR_.cljs$lang$applyTo = (function (arglist__14447){
var name = cljs.core.first(arglist__14447);
var r = cljs.core.rest(arglist__14447);
return make_object_STAR___delegate(name,r);
});
make_object_STAR_.cljs$core$IFn$_invoke$arity$variadic = make_object_STAR___delegate;
return make_object_STAR_;
})()
;
lt.object.store_object_STAR_ = (function store_object_STAR_(obj){lt.object.add.call(null,obj);
return obj;
});
/**
* Return all objects for given type (template name)
*/
lt.object.instances_by_type = (function instances_by_type(type){return cljs.core.filter.call(null,(function (p1__14448_SHARP_){return cljs.core._EQ_.call(null,type,new cljs.core.Keyword("lt.object","type","lt.object/type",701613666).cljs$core$IFn$_invoke$arity$1(cljs.core.deref.call(null,p1__14448_SHARP_)));
}),cljs.core.vals.call(null,cljs.core.deref.call(null,lt.object.instances)));
});
/**
* Merge map into object
*/
lt.object.merge_BANG_ = (function merge_BANG_(obj,m){if(cljs.core.truth_((function (){var and__3508__auto__ = m;if(cljs.core.truth_(and__3508__auto__))
{return !(cljs.core.map_QMARK_.call(null,m));
} else
{return and__3508__auto__;
}
})()))
{throw (new Error([cljs.core.str("Merge requires a map: "),cljs.core.str(m)].join('')));
} else
{}
return cljs.core.swap_BANG_.call(null,obj,cljs.core.merge,m);
});
lt.object.handle_redef = (function handle_redef(odef){var id = new cljs.core.Keyword("lt.object","type","lt.object/type",701613666).cljs$core$IFn$_invoke$arity$1(odef);var seq__14455_14461 = cljs.core.seq.call(null,lt.object.instances_by_type.call(null,id));var chunk__14457_14462 = null;var count__14458_14463 = 0;var i__14459_14464 = 0;while(true){
if((i__14459_14464 < count__14458_14463))
{var o_14465 = cljs.core._nth.call(null,chunk__14457_14462,i__14459_14464);var o_14466__$1 = cljs.core.deref.call(null,o_14465);var args_14467 = new cljs.core.Keyword(null,"args","args",1016906831).cljs$core$IFn$_invoke$arity$1(o_14466__$1);var old_14468 = new cljs.core.Keyword(null,"content","content",1965434859).cljs$core$IFn$_invoke$arity$1(o_14466__$1);var behs_14469 = cljs.core.set.call(null,new cljs.core.Keyword(null,"behaviors","behaviors",607554515).cljs$core$IFn$_invoke$arity$1(o_14466__$1));var inst_14470 = cljs.core.deref.call(null,lt.object.instances).call(null,lt.object.__GT_id.call(null,o_14466__$1));var neue_14471 = (cljs.core.truth_(new cljs.core.Keyword(null,"init","init",1017141378).cljs$core$IFn$_invoke$arity$1(odef))?cljs.core.apply.call(null,new cljs.core.Keyword(null,"init","init",1017141378).cljs$core$IFn$_invoke$arity$1(odef),inst_14470,args_14467):null);var neue_14472__$1 = ((cljs.core.vector_QMARK_.call(null,neue_14471))?crate.core.html.call(null,neue_14471):neue_14471);lt.object.merge_BANG_.call(null,inst_14470,new cljs.core.PersistentArrayMap(null, 3, [new cljs.core.Keyword(null,"tags","tags",1017456523),clojure.set.union.call(null,new cljs.core.Keyword(null,"tags","tags",1017456523).cljs$core$IFn$_invoke$arity$1(o_14466__$1),new cljs.core.Keyword(null,"tags","tags",1017456523).cljs$core$IFn$_invoke$arity$1(odef)),new cljs.core.Keyword(null,"behaviors","behaviors",607554515),clojure.set.union.call(null,behs_14469,cljs.core.set.call(null,new cljs.core.Keyword(null,"behaviors","behaviors",607554515).cljs$core$IFn$_invoke$arity$1(odef))),new cljs.core.Keyword(null,"content","content",1965434859),neue_14472__$1], null));
lt.object.merge_BANG_.call(null,inst_14470,lt.object.update_listeners.call(null,inst_14470));
if(cljs.core.truth_((function (){var and__3508__auto__ = old_14468;if(cljs.core.truth_(and__3508__auto__))
{return neue_14472__$1;
} else
{return and__3508__auto__;
}
})()))
{lt.util.dom.replace_with.call(null,old_14468,neue_14472__$1);
} else
{}
lt.object.raise.call(null,inst_14470,new cljs.core.Keyword(null,"redef","redef",1122293860));
{
var G__14473 = seq__14455_14461;
var G__14474 = chunk__14457_14462;
var G__14475 = count__14458_14463;
var G__14476 = (i__14459_14464 + 1);
seq__14455_14461 = G__14473;
chunk__14457_14462 = G__14474;
count__14458_14463 = G__14475;
i__14459_14464 = G__14476;
continue;
}
} else
{var temp__4092__auto___14477 = cljs.core.seq.call(null,seq__14455_14461);if(temp__4092__auto___14477)
{var seq__14455_14478__$1 = temp__4092__auto___14477;if(cljs.core.chunked_seq_QMARK_.call(null,seq__14455_14478__$1))
{var c__4262__auto___14479 = cljs.core.chunk_first.call(null,seq__14455_14478__$1);{
var G__14480 = cljs.core.chunk_rest.call(null,seq__14455_14478__$1);
var G__14481 = c__4262__auto___14479;
var G__14482 = cljs.core.count.call(null,c__4262__auto___14479);
var G__14483 = 0;
seq__14455_14461 = G__14480;
chunk__14457_14462 = G__14481;
count__14458_14463 = G__14482;
i__14459_14464 = G__14483;
continue;
}
} else
{var o_14484 = cljs.core.first.call(null,seq__14455_14478__$1);var o_14485__$1 = cljs.core.deref.call(null,o_14484);var args_14486 = new cljs.core.Keyword(null,"args","args",1016906831).cljs$core$IFn$_invoke$arity$1(o_14485__$1);var old_14487 = new cljs.core.Keyword(null,"content","content",1965434859).cljs$core$IFn$_invoke$arity$1(o_14485__$1);var behs_14488 = cljs.core.set.call(null,new cljs.core.Keyword(null,"behaviors","behaviors",607554515).cljs$core$IFn$_invoke$arity$1(o_14485__$1));var inst_14489 = cljs.core.deref.call(null,lt.object.instances).call(null,lt.object.__GT_id.call(null,o_14485__$1));var neue_14490 = (cljs.core.truth_(new cljs.core.Keyword(null,"init","init",1017141378).cljs$core$IFn$_invoke$arity$1(odef))?cljs.core.apply.call(null,new cljs.core.Keyword(null,"init","init",1017141378).cljs$core$IFn$_invoke$arity$1(odef),inst_14489,args_14486):null);var neue_14491__$1 = ((cljs.core.vector_QMARK_.call(null,neue_14490))?crate.core.html.call(null,neue_14490):neue_14490);lt.object.merge_BANG_.call(null,inst_14489,new cljs.core.PersistentArrayMap(null, 3, [new cljs.core.Keyword(null,"tags","tags",1017456523),clojure.set.union.call(null,new cljs.core.Keyword(null,"tags","tags",1017456523).cljs$core$IFn$_invoke$arity$1(o_14485__$1),new cljs.core.Keyword(null,"tags","tags",1017456523).cljs$core$IFn$_invoke$arity$1(odef)),new cljs.core.Keyword(null,"behaviors","behaviors",607554515),clojure.set.union.call(null,behs_14488,cljs.core.set.call(null,new cljs.core.Keyword(null,"behaviors","behaviors",607554515).cljs$core$IFn$_invoke$arity$1(odef))),new cljs.core.Keyword(null,"content","content",1965434859),neue_14491__$1], null));
lt.object.merge_BANG_.call(null,inst_14489,lt.object.update_listeners.call(null,inst_14489));
if(cljs.core.truth_((function (){var and__3508__auto__ = old_14487;if(cljs.core.truth_(and__3508__auto__))
{return neue_14491__$1;
} else
{return and__3508__auto__;
}
})()))
{lt.util.dom.replace_with.call(null,old_14487,neue_14491__$1);
} else
{}
lt.object.raise.call(null,inst_14489,new cljs.core.Keyword(null,"redef","redef",1122293860));
{
var G__14492 = cljs.core.next.call(null,seq__14455_14478__$1);
var G__14493 = null;
var G__14494 = 0;
var G__14495 = 0;
seq__14455_14461 = G__14492;
chunk__14457_14462 = G__14493;
count__14458_14463 = G__14494;
i__14459_14464 = G__14495;
continue;
}
}
} else
{}
}
break;
}
return id;
});
/**
* Create object template (type) given keyword name and key-value pairs.
* These pairs serve as default attributes for an object. Following keys
* have special meaning:
* 
* * :behaviors - Set of object's behaviors
* * :tags - Set of object's tags
* * :triggers - Set of object's triggers
* * :init - Init fn called when object is created. Fn's return value
* is hiccup html content and saved to :content
* * :listeners (internal) - Map of triggers to vectors of behaviors
* @param {...*} var_args
*/
lt.object.object_STAR_ = (function() { 
var object_STAR___delegate = function (name,r){return lt.object.handle_redef.call(null,lt.object.store_object_STAR_.call(null,cljs.core.apply.call(null,lt.object.make_object_STAR_,name,r)));
};
var object_STAR_ = function (name,var_args){
var r = null;if (arguments.length > 1) {
  r = cljs.core.array_seq(Array.prototype.slice.call(arguments, 1),0);} 
return object_STAR___delegate.call(this,name,r);};
object_STAR_.cljs$lang$maxFixedArity = 1;
object_STAR_.cljs$lang$applyTo = (function (arglist__14496){
var name = cljs.core.first(arglist__14496);
var r = cljs.core.rest(arglist__14496);
return object_STAR___delegate(name,r);
});
object_STAR_.cljs$core$IFn$_invoke$arity$variadic = object_STAR___delegate;
return object_STAR_;
})()
;
/**
* @param {...*} var_args
*/
lt.object.make_behavior_STAR_ = (function() { 
var make_behavior_STAR___delegate = function (name,r){var be = cljs.core.merge.call(null,new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"name","name",1017277949),name], null),cljs.core.apply.call(null,cljs.core.hash_map,r));return be;
};
var make_behavior_STAR_ = function (name,var_args){
var r = null;if (arguments.length > 1) {
  r = cljs.core.array_seq(Array.prototype.slice.call(arguments, 1),0);} 
return make_behavior_STAR___delegate.call(this,name,r);};
make_behavior_STAR_.cljs$lang$maxFixedArity = 1;
make_behavior_STAR_.cljs$lang$applyTo = (function (arglist__14497){
var name = cljs.core.first(arglist__14497);
var r = cljs.core.rest(arglist__14497);
return make_behavior_STAR___delegate(name,r);
});
make_behavior_STAR_.cljs$core$IFn$_invoke$arity$variadic = make_behavior_STAR___delegate;
return make_behavior_STAR_;
})()
;
lt.object.store_behavior_STAR_ = (function store_behavior_STAR_(beh){lt.object.add_behavior.call(null,beh);
return new cljs.core.Keyword(null,"name","name",1017277949).cljs$core$IFn$_invoke$arity$1(beh);
});
lt.object.wrap_throttle = (function wrap_throttle(beh){var temp__4090__auto__ = new cljs.core.Keyword(null,"throttle","throttle",2497347228).cljs$core$IFn$_invoke$arity$1(beh);if(cljs.core.truth_(temp__4090__auto__))
{var thr = temp__4090__auto__;return cljs.core.assoc.call(null,beh,new cljs.core.Keyword(null,"reaction","reaction",4441361819),lt.util.js.throttle.call(null,thr,new cljs.core.Keyword(null,"reaction","reaction",4441361819).cljs$core$IFn$_invoke$arity$1(beh)));
} else
{return beh;
}
});
lt.object.wrap_debounce = (function wrap_debounce(beh){var temp__4090__auto__ = new cljs.core.Keyword(null,"debounce","debounce",1556599227).cljs$core$IFn$_invoke$arity$1(beh);if(cljs.core.truth_(temp__4090__auto__))
{var thr = temp__4090__auto__;return cljs.core.assoc.call(null,beh,new cljs.core.Keyword(null,"reaction","reaction",4441361819),lt.util.js.debounce.call(null,thr,new cljs.core.Keyword(null,"reaction","reaction",4441361819).cljs$core$IFn$_invoke$arity$1(beh)));
} else
{return beh;
}
});
/**
* @param {...*} var_args
*/
lt.object.behavior_STAR_ = (function() { 
var behavior_STAR___delegate = function (name,r){return lt.object.store_behavior_STAR_.call(null,lt.object.wrap_debounce.call(null,lt.object.wrap_throttle.call(null,cljs.core.apply.call(null,lt.object.make_behavior_STAR_,name,r))));
};
var behavior_STAR_ = function (name,var_args){
var r = null;if (arguments.length > 1) {
  r = cljs.core.array_seq(Array.prototype.slice.call(arguments, 1),0);} 
return behavior_STAR___delegate.call(this,name,r);};
behavior_STAR_.cljs$lang$maxFixedArity = 1;
behavior_STAR_.cljs$lang$applyTo = (function (arglist__14498){
var name = cljs.core.first(arglist__14498);
var r = cljs.core.rest(arglist__14498);
return behavior_STAR___delegate(name,r);
});
behavior_STAR_.cljs$core$IFn$_invoke$arity$variadic = behavior_STAR___delegate;
return behavior_STAR_;
})()
;
/**
* Reduce over invoked object's behavior fns for given trigger. Start
* is initial value for reduce and any args are passed to behavior fn
* @param {...*} var_args
*/
lt.object.raise_reduce = (function() { 
var raise_reduce__delegate = function (obj,k,start,args){var reactions = k.call(null,new cljs.core.Keyword(null,"listeners","listeners",4090152369).cljs$core$IFn$_invoke$arity$1(cljs.core.deref.call(null,obj)));return cljs.core.reduce.call(null,(function (res,cur){var func = new cljs.core.Keyword(null,"reaction","reaction",4441361819).cljs$core$IFn$_invoke$arity$1(lt.object.__GT_behavior.call(null,cur));var args__$1 = ((cljs.core.coll_QMARK_.call(null,cur))?cljs.core.concat.call(null,cljs.core.rest.call(null,cur),args):args);var meta = ((cljs.core.coll_QMARK_.call(null,cur))?cljs.core.meta.call(null,cur):cljs.core.PersistentArrayMap.EMPTY);if(cljs.core.not.call(null,func))
{return res;
} else
{var _STAR_behavior_meta_STAR_14500 = lt.object._STAR_behavior_meta_STAR_;try{lt.object._STAR_behavior_meta_STAR_ = meta;
return cljs.core.apply.call(null,func,obj,res,args__$1);
}finally {lt.object._STAR_behavior_meta_STAR_ = _STAR_behavior_meta_STAR_14500;
}}
}),start,reactions);
};
var raise_reduce = function (obj,k,start,var_args){
var args = null;if (arguments.length > 3) {
  args = cljs.core.array_seq(Array.prototype.slice.call(arguments, 3),0);} 
return raise_reduce__delegate.call(this,obj,k,start,args);};
raise_reduce.cljs$lang$maxFixedArity = 3;
raise_reduce.cljs$lang$applyTo = (function (arglist__14501){
var obj = cljs.core.first(arglist__14501);
arglist__14501 = cljs.core.next(arglist__14501);
var k = cljs.core.first(arglist__14501);
arglist__14501 = cljs.core.next(arglist__14501);
var start = cljs.core.first(arglist__14501);
var args = cljs.core.rest(arglist__14501);
return raise_reduce__delegate(obj,k,start,args);
});
raise_reduce.cljs$core$IFn$_invoke$arity$variadic = raise_reduce__delegate;
return raise_reduce;
})()
;
/**
* Update object with update-in with [:key], fn and args
* @param {...*} var_args
*/
lt.object.update_BANG_ = (function() { 
var update_BANG___delegate = function (obj,r){return cljs.core.swap_BANG_.call(null,obj,(function (p1__14502_SHARP_){return cljs.core.apply.call(null,cljs.core.update_in,p1__14502_SHARP_,r);
}));
};
var update_BANG_ = function (obj,var_args){
var r = null;if (arguments.length > 1) {
  r = cljs.core.array_seq(Array.prototype.slice.call(arguments, 1),0);} 
return update_BANG___delegate.call(this,obj,r);};
update_BANG_.cljs$lang$maxFixedArity = 1;
update_BANG_.cljs$lang$applyTo = (function (arglist__14503){
var obj = cljs.core.first(arglist__14503);
var r = cljs.core.rest(arglist__14503);
return update_BANG___delegate(obj,r);
});
update_BANG_.cljs$core$IFn$_invoke$arity$variadic = update_BANG___delegate;
return update_BANG_;
})()
;
/**
* Update object with assoc-in for given key and value
*/
lt.object.assoc_in_BANG_ = (function assoc_in_BANG_(obj,k,v){if(cljs.core.truth_((function (){var and__3508__auto__ = k;if(cljs.core.truth_(and__3508__auto__))
{return !(cljs.core.sequential_QMARK_.call(null,k));
} else
{return and__3508__auto__;
}
})()))
{throw (new Error([cljs.core.str("Associate requires a sequence of keys: "),cljs.core.str(k)].join('')));
} else
{}
return cljs.core.swap_BANG_.call(null,obj,(function (p1__14504_SHARP_){return cljs.core.assoc_in.call(null,p1__14504_SHARP_,k,v);
}));
});
lt.object.__GT_inst = (function __GT_inst(o){if(cljs.core.map_QMARK_.call(null,o))
{return cljs.core.deref.call(null,lt.object.instances).call(null,lt.object.__GT_id.call(null,o));
} else
{if(crate.binding.deref_QMARK_.call(null,o))
{return o;
} else
{if(new cljs.core.Keyword(null,"else","else",1017020587))
{return cljs.core.deref.call(null,lt.object.instances).call(null,o);
} else
{return null;
}
}
}
});
/**
* Return DOM content associated with object
*/
lt.object.__GT_content = (function __GT_content(obj){return new cljs.core.Keyword(null,"content","content",1965434859).cljs$core$IFn$_invoke$arity$1(cljs.core.deref.call(null,obj));
});
/**
* Destroy object by calling its :destroy trigger, removing it from
* cache and removing associated DOM content
*/
lt.object.destroy_BANG_ = (function destroy_BANG_(obj){var temp__4092__auto__ = lt.object.__GT_inst.call(null,obj);if(cljs.core.truth_(temp__4092__auto__))
{var inst = temp__4092__auto__;lt.object.raise.call(null,inst,new cljs.core.Keyword(null,"destroy","destroy",2571277164));
cljs.core.swap_BANG_.call(null,lt.object.instances,cljs.core.dissoc,lt.object.__GT_id.call(null,inst));
if(cljs.core.truth_(lt.object.__GT_content.call(null,obj)))
{lt.util.dom.remove.call(null,lt.object.__GT_content.call(null,obj));
} else
{}
return cljs.core.reset_BANG_.call(null,obj,null);
} else
{return null;
}
});
lt.object.store_inst = (function store_inst(inst){cljs.core.swap_BANG_.call(null,lt.object.instances,cljs.core.assoc,new cljs.core.Keyword("lt.object","id","lt.object/id",706431105).cljs$core$IFn$_invoke$arity$1(cljs.core.deref.call(null,inst)),inst);
return inst;
});
/**
* Create object given keyword name of object template or an object template
* and key-value pairs. See object* for special keys.
* During object creation the following happens to object in order:
* 
* * :init fn is called with given args
* * :object.instant trigger is raised
* * :init trigger is raised
* @param {...*} var_args
*/
lt.object.create = (function() { 
var create__delegate = function (obj_name,args){var obj = (((obj_name instanceof cljs.core.Keyword))?cljs.core.deref.call(null,lt.object.object_defs).call(null,obj_name):obj_name);var id = (function (){var or__3520__auto__ = new cljs.core.Keyword("lt.object","id","lt.object/id",706431105).cljs$core$IFn$_invoke$arity$1(obj);if(cljs.core.truth_(or__3520__auto__))
{return or__3520__auto__;
} else
{return cljs.core.swap_BANG_.call(null,lt.object.obj_id,cljs.core.inc);
}
})();var inst = cljs.core.atom.call(null,cljs.core.assoc.call(null,cljs.core.dissoc.call(null,obj,new cljs.core.Keyword(null,"init","init",1017141378)),new cljs.core.Keyword("lt.object","id","lt.object/id",706431105),id,new cljs.core.Keyword(null,"args","args",1016906831),args,new cljs.core.Keyword(null,"behaviors","behaviors",607554515),cljs.core.set.call(null,new cljs.core.Keyword(null,"behaviors","behaviors",607554515).cljs$core$IFn$_invoke$arity$1(obj)),new cljs.core.Keyword(null,"tags","tags",1017456523),cljs.core.set.call(null,cljs.core.conj.call(null,new cljs.core.Keyword(null,"tags","tags",1017456523).cljs$core$IFn$_invoke$arity$1(obj),new cljs.core.Keyword(null,"object","object",4285503153)))));var inst__$1 = lt.object.store_inst.call(null,inst);var _ = lt.object.merge_BANG_.call(null,inst__$1,lt.object.update_listeners.call(null,inst__$1));var content = (cljs.core.truth_(new cljs.core.Keyword(null,"init","init",1017141378).cljs$core$IFn$_invoke$arity$1(obj))?cljs.core.apply.call(null,new cljs.core.Keyword(null,"init","init",1017141378).cljs$core$IFn$_invoke$arity$1(obj),inst__$1,args):null);var content__$1 = ((cljs.core.vector_QMARK_.call(null,content))?crate.core.html.call(null,content):content);var final$ = lt.object.merge_BANG_.call(null,inst__$1,new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"content","content",1965434859),content__$1], null));cljs.core.add_watch.call(null,inst__$1,new cljs.core.Keyword("lt.object","change","lt.object/change",2456955616),(function (___$1,___$2,___$3,___$4){return lt.object.raise.call(null,inst__$1,new cljs.core.Keyword(null,"object.change","object.change",966833329));
}));
lt.object.raise_STAR_.call(null,inst__$1,lt.object.trigger__GT_behaviors.call(null,new cljs.core.Keyword(null,"object.instant","object.instant",773332388),new cljs.core.Keyword(null,"tags","tags",1017456523).cljs$core$IFn$_invoke$arity$1(cljs.core.deref.call(null,inst__$1))),null);
lt.object.raise.call(null,inst__$1,new cljs.core.Keyword(null,"init","init",1017141378));
return inst__$1;
};
var create = function (obj_name,var_args){
var args = null;if (arguments.length > 1) {
  args = cljs.core.array_seq(Array.prototype.slice.call(arguments, 1),0);} 
return create__delegate.call(this,obj_name,args);};
create.cljs$lang$maxFixedArity = 1;
create.cljs$lang$applyTo = (function (arglist__14505){
var obj_name = cljs.core.first(arglist__14505);
var args = cljs.core.rest(arglist__14505);
return create__delegate(obj_name,args);
});
create.cljs$core$IFn$_invoke$arity$variadic = create__delegate;
return create;
})()
;
lt.object.refresh_BANG_ = (function refresh_BANG_(obj){cljs.core.reset_BANG_.call(null,obj,lt.object.update_listeners.call(null,obj));
lt.object.raise_STAR_.call(null,obj,lt.object.trigger__GT_behaviors.call(null,new cljs.core.Keyword(null,"object.instant","object.instant",773332388),new cljs.core.Keyword(null,"tags","tags",1017456523).cljs$core$IFn$_invoke$arity$1(cljs.core.deref.call(null,obj))),null);
return lt.object.raise.call(null,obj,new cljs.core.Keyword(null,"object.refresh","object.refresh",4196174494));
});
/**
* Add behavior to object and update its listeners
*/
lt.object.add_behavior_BANG_ = (function add_behavior_BANG_(obj,behavior){lt.object.update_BANG_.call(null,obj,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"behaviors","behaviors",607554515)], null),cljs.core.conj,behavior);
return cljs.core.reset_BANG_.call(null,obj,lt.object.update_listeners.call(null,obj));
});
/**
* Remove behavior from object and update its listeners
*/
lt.object.rem_behavior_BANG_ = (function rem_behavior_BANG_(obj,behavior){lt.object.update_BANG_.call(null,obj,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"behaviors","behaviors",607554515)], null),(function (p1__14506_SHARP_){return cljs.core.remove.call(null,cljs.core.PersistentHashSet.fromArray([behavior], true),p1__14506_SHARP_);
}));
return cljs.core.reset_BANG_.call(null,obj,lt.object.update_listeners.call(null,obj));
});
lt.object.__GT_def = (function __GT_def(def_BAR_name){if(cljs.core.map_QMARK_.call(null,def_BAR_name))
{return def_BAR_name;
} else
{return cljs.core.deref.call(null,lt.object.object_defs).call(null,def_BAR_name);
}
});
/**
* Find object by its unique numerical id
*/
lt.object.by_id = (function by_id(id){if(cljs.core.truth_(id))
{return cljs.core.deref.call(null,lt.object.instances).call(null,id);
} else
{return null;
}
});
/**
* Find objects that have given tag
*/
lt.object.by_tag = (function by_tag(tag){return cljs.core.sort_by.call(null,cljs.core.comp.call(null,new cljs.core.Keyword("lt.object","id","lt.object/id",706431105),cljs.core.deref),cljs.core.filter.call(null,(function (p1__14507_SHARP_){var temp__4092__auto__ = new cljs.core.Keyword(null,"tags","tags",1017456523).cljs$core$IFn$_invoke$arity$1(cljs.core.deref.call(null,p1__14507_SHARP_));if(cljs.core.truth_(temp__4092__auto__))
{var ts = temp__4092__auto__;return ts.call(null,tag);
} else
{return null;
}
}),cljs.core.vals.call(null,cljs.core.deref.call(null,lt.object.instances))));
});
lt.object.in_tag_QMARK_ = (function in_tag_QMARK_(tag,behavior){return cljs.core.first.call(null,cljs.core.filter.call(null,cljs.core.PersistentHashSet.fromArray([behavior], true),cljs.core.deref.call(null,lt.object.tags).call(null,tag)));
});
/**
* Return truthy if object has tag
*/
lt.object.has_tag_QMARK_ = (function has_tag_QMARK_(obj,tag){return new cljs.core.Keyword(null,"tags","tags",1017456523).cljs$core$IFn$_invoke$arity$1(cljs.core.deref.call(null,obj)).call(null,tag);
});
/**
* Add tags to given object and updates effected behaviors and listeners.
* ::tags-added trigger is raised on object after update
*/
lt.object.add_tags = (function add_tags(obj,ts){lt.object.update_BANG_.call(null,obj,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"tags","tags",1017456523)], null),(function (p1__14508_SHARP_){return cljs.core.reduce.call(null,cljs.core.conj,p1__14508_SHARP_,cljs.core.filter.call(null,cljs.core.identity,ts));
}));
cljs.core.reset_BANG_.call(null,obj,lt.object.update_listeners.call(null,obj));
lt.object.raise.call(null,obj,new cljs.core.Keyword("lt.object","tags-added","lt.object/tags-added",1756253556),ts);
lt.object.raise_STAR_.call(null,obj,lt.object.trigger__GT_behaviors.call(null,new cljs.core.Keyword(null,"object.instant","object.instant",773332388),ts),null);
return obj;
});
/**
* Remove tags from given object and updates effected behaviors and listeners.
* ::tags-removed trigger is raised on object after update
*/
lt.object.remove_tags = (function remove_tags(obj,ts){var cur = cljs.core.deref.call(null,obj);var behs = cljs.core.apply.call(null,cljs.core.concat,cljs.core.map.call(null,cljs.core.deref.call(null,lt.object.tags),ts));var cur__$1 = cljs.core.update_in.call(null,cljs.core.update_in.call(null,cljs.core.update_in.call(null,cur,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"tags","tags",1017456523)], null),((function (cur,behs){
return (function (p1__14509_SHARP_){return cljs.core.reduce.call(null,cljs.core.disj,p1__14509_SHARP_,ts);
});})(cur,behs))
),new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"behaviors","behaviors",607554515)], null),((function (cur,behs){
return (function (p1__14510_SHARP_){return cljs.core.remove.call(null,cljs.core.PersistentHashSet.fromArray([behs], true),p1__14510_SHARP_);
});})(cur,behs))
),new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"listeners","listeners",4090152369)], null),((function (cur,behs){
return (function (p1__14511_SHARP_){return cljs.core.apply.call(null,cljs.core.dissoc,p1__14511_SHARP_,ts);
});})(cur,behs))
);lt.object.merge_BANG_.call(null,obj,cur__$1);
cljs.core.reset_BANG_.call(null,obj,lt.object.update_listeners.call(null,obj));
lt.object.raise.call(null,obj,new cljs.core.Keyword("lt.object","tags-removed","lt.object/tags-removed",4080090644),ts);
return obj;
});
/**
* Associate behaviors to given tag and refresh objects with given tag
*/
lt.object.tag_behaviors = (function tag_behaviors(tag,behs){cljs.core.swap_BANG_.call(null,lt.object.tags,cljs.core.update_in,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [tag], null),(function (p1__14512_SHARP_){return cljs.core.reduce.call(null,cljs.core.conj,(function (){var or__3520__auto__ = p1__14512_SHARP_;if(cljs.core.truth_(or__3520__auto__))
{return or__3520__auto__;
} else
{return cljs.core.List.EMPTY;
}
})(),behs);
}));
var seq__14517_14521 = cljs.core.seq.call(null,lt.object.by_tag.call(null,tag));var chunk__14518_14522 = null;var count__14519_14523 = 0;var i__14520_14524 = 0;while(true){
if((i__14520_14524 < count__14519_14523))
{var cur_14525 = cljs.core._nth.call(null,chunk__14518_14522,i__14520_14524);lt.object.refresh_BANG_.call(null,cur_14525);
{
var G__14526 = seq__14517_14521;
var G__14527 = chunk__14518_14522;
var G__14528 = count__14519_14523;
var G__14529 = (i__14520_14524 + 1);
seq__14517_14521 = G__14526;
chunk__14518_14522 = G__14527;
count__14519_14523 = G__14528;
i__14520_14524 = G__14529;
continue;
}
} else
{var temp__4092__auto___14530 = cljs.core.seq.call(null,seq__14517_14521);if(temp__4092__auto___14530)
{var seq__14517_14531__$1 = temp__4092__auto___14530;if(cljs.core.chunked_seq_QMARK_.call(null,seq__14517_14531__$1))
{var c__4262__auto___14532 = cljs.core.chunk_first.call(null,seq__14517_14531__$1);{
var G__14533 = cljs.core.chunk_rest.call(null,seq__14517_14531__$1);
var G__14534 = c__4262__auto___14532;
var G__14535 = cljs.core.count.call(null,c__4262__auto___14532);
var G__14536 = 0;
seq__14517_14521 = G__14533;
chunk__14518_14522 = G__14534;
count__14519_14523 = G__14535;
i__14520_14524 = G__14536;
continue;
}
} else
{var cur_14537 = cljs.core.first.call(null,seq__14517_14531__$1);lt.object.refresh_BANG_.call(null,cur_14537);
{
var G__14538 = cljs.core.next.call(null,seq__14517_14531__$1);
var G__14539 = null;
var G__14540 = 0;
var G__14541 = 0;
seq__14517_14521 = G__14538;
chunk__14518_14522 = G__14539;
count__14519_14523 = G__14540;
i__14520_14524 = G__14541;
continue;
}
}
} else
{}
}
break;
}
return cljs.core.deref.call(null,lt.object.tags).call(null,tag);
});
lt.object.remove_tag_behaviors = (function remove_tag_behaviors(tag,behs){cljs.core.swap_BANG_.call(null,lt.object.tags,cljs.core.update_in,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [tag], null),(function (p1__14542_SHARP_){return cljs.core.remove.call(null,cljs.core.set.call(null,behs),(function (){var or__3520__auto__ = p1__14542_SHARP_;if(cljs.core.truth_(or__3520__auto__))
{return or__3520__auto__;
} else
{return cljs.core.List.EMPTY;
}
})());
}));
var seq__14555 = cljs.core.seq.call(null,lt.object.by_tag.call(null,tag));var chunk__14560 = null;var count__14561 = 0;var i__14562 = 0;while(true){
if((i__14562 < count__14561))
{var cur = cljs.core._nth.call(null,chunk__14560,i__14562);var seq__14563_14567 = cljs.core.seq.call(null,behs);var chunk__14564_14568 = null;var count__14565_14569 = 0;var i__14566_14570 = 0;while(true){
if((i__14566_14570 < count__14565_14569))
{var b_14571 = cljs.core._nth.call(null,chunk__14564_14568,i__14566_14570);lt.object.rem_behavior_BANG_.call(null,cur,b_14571);
{
var G__14572 = seq__14563_14567;
var G__14573 = chunk__14564_14568;
var G__14574 = count__14565_14569;
var G__14575 = (i__14566_14570 + 1);
seq__14563_14567 = G__14572;
chunk__14564_14568 = G__14573;
count__14565_14569 = G__14574;
i__14566_14570 = G__14575;
continue;
}
} else
{var temp__4092__auto___14576 = cljs.core.seq.call(null,seq__14563_14567);if(temp__4092__auto___14576)
{var seq__14563_14577__$1 = temp__4092__auto___14576;if(cljs.core.chunked_seq_QMARK_.call(null,seq__14563_14577__$1))
{var c__4262__auto___14578 = cljs.core.chunk_first.call(null,seq__14563_14577__$1);{
var G__14579 = cljs.core.chunk_rest.call(null,seq__14563_14577__$1);
var G__14580 = c__4262__auto___14578;
var G__14581 = cljs.core.count.call(null,c__4262__auto___14578);
var G__14582 = 0;
seq__14563_14567 = G__14579;
chunk__14564_14568 = G__14580;
count__14565_14569 = G__14581;
i__14566_14570 = G__14582;
continue;
}
} else
{var b_14583 = cljs.core.first.call(null,seq__14563_14577__$1);lt.object.rem_behavior_BANG_.call(null,cur,b_14583);
{
var G__14584 = cljs.core.next.call(null,seq__14563_14577__$1);
var G__14585 = null;
var G__14586 = 0;
var G__14587 = 0;
seq__14563_14567 = G__14584;
chunk__14564_14568 = G__14585;
count__14565_14569 = G__14586;
i__14566_14570 = G__14587;
continue;
}
}
} else
{}
}
break;
}
{
var G__14588 = seq__14555;
var G__14589 = chunk__14560;
var G__14590 = count__14561;
var G__14591 = (i__14562 + 1);
seq__14555 = G__14588;
chunk__14560 = G__14589;
count__14561 = G__14590;
i__14562 = G__14591;
continue;
}
} else
{var temp__4092__auto__ = cljs.core.seq.call(null,seq__14555);if(temp__4092__auto__)
{var seq__14555__$1 = temp__4092__auto__;if(cljs.core.chunked_seq_QMARK_.call(null,seq__14555__$1))
{var c__4262__auto__ = cljs.core.chunk_first.call(null,seq__14555__$1);{
var G__14592 = cljs.core.chunk_rest.call(null,seq__14555__$1);
var G__14593 = c__4262__auto__;
var G__14594 = cljs.core.count.call(null,c__4262__auto__);
var G__14595 = 0;
seq__14555 = G__14592;
chunk__14560 = G__14593;
count__14561 = G__14594;
i__14562 = G__14595;
continue;
}
} else
{var cur = cljs.core.first.call(null,seq__14555__$1);var seq__14556_14596 = cljs.core.seq.call(null,behs);var chunk__14557_14597 = null;var count__14558_14598 = 0;var i__14559_14599 = 0;while(true){
if((i__14559_14599 < count__14558_14598))
{var b_14600 = cljs.core._nth.call(null,chunk__14557_14597,i__14559_14599);lt.object.rem_behavior_BANG_.call(null,cur,b_14600);
{
var G__14601 = seq__14556_14596;
var G__14602 = chunk__14557_14597;
var G__14603 = count__14558_14598;
var G__14604 = (i__14559_14599 + 1);
seq__14556_14596 = G__14601;
chunk__14557_14597 = G__14602;
count__14558_14598 = G__14603;
i__14559_14599 = G__14604;
continue;
}
} else
{var temp__4092__auto___14605__$1 = cljs.core.seq.call(null,seq__14556_14596);if(temp__4092__auto___14605__$1)
{var seq__14556_14606__$1 = temp__4092__auto___14605__$1;if(cljs.core.chunked_seq_QMARK_.call(null,seq__14556_14606__$1))
{var c__4262__auto___14607 = cljs.core.chunk_first.call(null,seq__14556_14606__$1);{
var G__14608 = cljs.core.chunk_rest.call(null,seq__14556_14606__$1);
var G__14609 = c__4262__auto___14607;
var G__14610 = cljs.core.count.call(null,c__4262__auto___14607);
var G__14611 = 0;
seq__14556_14596 = G__14608;
chunk__14557_14597 = G__14609;
count__14558_14598 = G__14610;
i__14559_14599 = G__14611;
continue;
}
} else
{var b_14612 = cljs.core.first.call(null,seq__14556_14606__$1);lt.object.rem_behavior_BANG_.call(null,cur,b_14612);
{
var G__14613 = cljs.core.next.call(null,seq__14556_14606__$1);
var G__14614 = null;
var G__14615 = 0;
var G__14616 = 0;
seq__14556_14596 = G__14613;
chunk__14557_14597 = G__14614;
count__14558_14598 = G__14615;
i__14559_14599 = G__14616;
continue;
}
}
} else
{}
}
break;
}
{
var G__14617 = cljs.core.next.call(null,seq__14555__$1);
var G__14618 = null;
var G__14619 = 0;
var G__14620 = 0;
seq__14555 = G__14617;
chunk__14560 = G__14618;
count__14561 = G__14619;
i__14562 = G__14620;
continue;
}
}
} else
{return null;
}
}
break;
}
});
lt.object.__BEH__add_tag = (function __BEH__add_tag(this$,t){if(cljs.core.truth_(t))
{return lt.object.add_tags.call(null,this$,((cljs.core.coll_QMARK_.call(null,t))?t:new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [t], null)));
} else
{return null;
}
});
lt.object.behavior_STAR_.call(null,new cljs.core.Keyword("lt.object","add-tag","lt.object/add-tag",1703923742),new cljs.core.Keyword(null,"reaction","reaction",4441361819),lt.object.__BEH__add_tag,new cljs.core.Keyword(null,"desc","desc",1016984067),"App: Add tag to object",new cljs.core.Keyword(null,"params","params",4313443576),new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"label","label",1116631654),"tag"], null)], null),new cljs.core.Keyword(null,"triggers","triggers",2516997421),new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"object.instant","object.instant",773332388),null], null), null),new cljs.core.Keyword(null,"type","type",1017479852),new cljs.core.Keyword(null,"user","user",1017503549));
lt.object.__BEH__remove_tag = (function __BEH__remove_tag(this$,t){if(cljs.core.truth_(lt.object.has_tag_QMARK_.call(null,this$,t)))
{return lt.object.remove_tags.call(null,this$,((cljs.core.coll_QMARK_.call(null,t))?t:new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [t], null)));
} else
{return null;
}
});
lt.object.behavior_STAR_.call(null,new cljs.core.Keyword("lt.object","remove-tag","lt.object/remove-tag",3883925951),new cljs.core.Keyword(null,"reaction","reaction",4441361819),lt.object.__BEH__remove_tag,new cljs.core.Keyword(null,"desc","desc",1016984067),"App: Remove tag from object",new cljs.core.Keyword(null,"params","params",4313443576),new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"label","label",1116631654),"tag"], null)], null),new cljs.core.Keyword(null,"triggers","triggers",2516997421),new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"object.instant","object.instant",773332388),null,new cljs.core.Keyword("lt.object","tags-added","lt.object/tags-added",1756253556),null], null), null),new cljs.core.Keyword(null,"type","type",1017479852),new cljs.core.Keyword(null,"user","user",1017503549));
lt.object.__BEH__shadow_tag = (function __BEH__shadow_tag(this$,to_shadow,to_add){var has_shadow_QMARK_ = lt.object.has_tag_QMARK_.call(null,this$,to_shadow);var has_add_QMARK_ = lt.object.has_tag_QMARK_.call(null,this$,to_add);if(cljs.core.truth_((function (){var and__3508__auto__ = has_shadow_QMARK_;if(cljs.core.truth_(and__3508__auto__))
{return cljs.core.not.call(null,has_add_QMARK_);
} else
{return and__3508__auto__;
}
})()))
{return lt.object.add_tags.call(null,this$,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [to_add], null));
} else
{if(cljs.core.truth_((function (){var and__3508__auto__ = cljs.core.not.call(null,has_shadow_QMARK_);if(and__3508__auto__)
{return has_add_QMARK_;
} else
{return and__3508__auto__;
}
})()))
{return lt.object.remove_tags.call(null,this$,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [to_add], null));
} else
{if(new cljs.core.Keyword(null,"else","else",1017020587))
{return null;
} else
{return null;
}
}
}
});
lt.object.behavior_STAR_.call(null,new cljs.core.Keyword("lt.object","shadow-tag","lt.object/shadow-tag",1731213395),new cljs.core.Keyword(null,"reaction","reaction",4441361819),lt.object.__BEH__shadow_tag,new cljs.core.Keyword(null,"desc","desc",1016984067),"App: Shadow a tag on an object",new cljs.core.Keyword(null,"params","params",4313443576),new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"label","label",1116631654),"tag to shadow"], null),new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"label","label",1116631654),"tag to add"], null)], null),new cljs.core.Keyword(null,"triggers","triggers",2516997421),new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 3, [new cljs.core.Keyword(null,"object.instant","object.instant",773332388),null,new cljs.core.Keyword("lt.object","tags-added","lt.object/tags-added",1756253556),null,new cljs.core.Keyword("lt.object","tags-removed","lt.object/tags-removed",4080090644),null], null), null),new cljs.core.Keyword(null,"type","type",1017479852),new cljs.core.Keyword(null,"user","user",1017503549));
lt.object.__BEH__report_time = (function __BEH__report_time(this$,beh,time,trigger){if(cljs.core.truth_(lt.objs.console))
{return lt.objs.console.log([cljs.core.str(beh),cljs.core.str(" triggered by "),cljs.core.str(trigger),cljs.core.str(" took "),cljs.core.str(time),cljs.core.str("ms")].join(''));
} else
{return null;
}
});
lt.object.behavior_STAR_.call(null,new cljs.core.Keyword("lt.object","report-time","lt.object/report-time",1387009782),new cljs.core.Keyword(null,"reaction","reaction",4441361819),lt.object.__BEH__report_time,new cljs.core.Keyword(null,"triggers","triggers",2516997421),new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"object.behavior.time","object.behavior.time",854340588),null], null), null));
