// Compiled by ClojureScript 0.0-2138
goog.provide('lt.util.dom');
goog.require('cljs.core');
lt.util.dom.lazy_nl_via_item = (function() {
var lazy_nl_via_item = null;
var lazy_nl_via_item__1 = (function (nl){return lazy_nl_via_item.call(null,nl,0);
});
var lazy_nl_via_item__2 = (function (nl,n){if((n < nl.length))
{return (new cljs.core.LazySeq(null,(function (){return cljs.core.cons.call(null,nl.item(n),lazy_nl_via_item.call(null,nl,(n + 1)));
}),null,null));
} else
{return null;
}
});
lazy_nl_via_item = function(nl,n){
switch(arguments.length){
case 1:
return lazy_nl_via_item__1.call(this,nl);
case 2:
return lazy_nl_via_item__2.call(this,nl,n);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
lazy_nl_via_item.cljs$core$IFn$_invoke$arity$1 = lazy_nl_via_item__1;
lazy_nl_via_item.cljs$core$IFn$_invoke$arity$2 = lazy_nl_via_item__2;
return lazy_nl_via_item;
})()
;
HTMLCollection.prototype.cljs$core$IIndexed$ = true;
HTMLCollection.prototype.cljs$core$IIndexed$_nth$arity$2 = (function (this$,n){var this$__$1 = this;return this$__$1.item(n);
});
HTMLCollection.prototype.cljs$core$IIndexed$_nth$arity$3 = (function (this$,n,not_found){var this$__$1 = this;var or__3520__auto__ = this$__$1.item(n);if(cljs.core.truth_(or__3520__auto__))
{return or__3520__auto__;
} else
{return not_found;
}
});
HTMLCollection.prototype.cljs$core$ICounted$ = true;
HTMLCollection.prototype.cljs$core$ICounted$_count$arity$1 = (function (this$){var this$__$1 = this;return this$__$1.length;
});
HTMLCollection.prototype.cljs$core$ISeqable$ = true;
HTMLCollection.prototype.cljs$core$ISeqable$_seq$arity$1 = (function (this$){var this$__$1 = this;return lt.util.dom.lazy_nl_via_item.call(null,this$__$1);
});
NodeList.prototype.cljs$core$IIndexed$ = true;
NodeList.prototype.cljs$core$IIndexed$_nth$arity$2 = (function (this$,n){var this$__$1 = this;return this$__$1.item(n);
});
NodeList.prototype.cljs$core$IIndexed$_nth$arity$3 = (function (this$,n,not_found){var this$__$1 = this;var or__3520__auto__ = this$__$1.item(n);if(cljs.core.truth_(or__3520__auto__))
{return or__3520__auto__;
} else
{return not_found;
}
});
NodeList.prototype.cljs$core$ICounted$ = true;
NodeList.prototype.cljs$core$ICounted$_count$arity$1 = (function (this$){var this$__$1 = this;return this$__$1.length;
});
NodeList.prototype.cljs$core$ISeqable$ = true;
NodeList.prototype.cljs$core$ISeqable$_seq$arity$1 = (function (this$){var this$__$1 = this;return lt.util.dom.lazy_nl_via_item.call(null,this$__$1);
});
lt.util.dom.text_node = (function text_node(text){return document.createTextNode(text);
});
lt.util.dom.$$ = (function() {
var $$ = null;
var $$__1 = (function (query){return $$.call(null,query,document);
});
var $$__2 = (function (query,elem){return elem.querySelectorAll(cljs.core.name.call(null,query));
});
$$ = function(query,elem){
switch(arguments.length){
case 1:
return $$__1.call(this,query);
case 2:
return $$__2.call(this,query,elem);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
$$.cljs$core$IFn$_invoke$arity$1 = $$__1;
$$.cljs$core$IFn$_invoke$arity$2 = $$__2;
return $$;
})()
;
lt.util.dom.$ = (function() {
var $ = null;
var $__1 = (function (query){return $.call(null,query,document);
});
var $__2 = (function (query,elem){return elem.querySelector(cljs.core.name.call(null,query));
});
$ = function(query,elem){
switch(arguments.length){
case 1:
return $__1.call(this,query);
case 2:
return $__2.call(this,query,elem);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
$.cljs$core$IFn$_invoke$arity$1 = $__1;
$.cljs$core$IFn$_invoke$arity$2 = $__2;
return $;
})()
;
lt.util.dom.append = (function append(parent,child){parent.appendChild(child);
return parent;
});
lt.util.dom.prepend = (function prepend(parent,child){if(cljs.core.truth_(parent.firstChild))
{return parent.insertBefore(child,parent.firstChild);
} else
{return lt.util.dom.append.call(null,parent,child);
}
});
lt.util.dom.add_class = (function add_class(elem,class$){if(cljs.core.truth_((function (){var and__3508__auto__ = elem;if(cljs.core.truth_(and__3508__auto__))
{return !(cljs.core.empty_QMARK_.call(null,cljs.core.name.call(null,class$)));
} else
{return and__3508__auto__;
}
})()))
{return elem.classList.add(cljs.core.name.call(null,class$));
} else
{return null;
}
});
lt.util.dom.remove_class = (function remove_class(elem,class$){if(cljs.core.truth_((function (){var and__3508__auto__ = elem;if(cljs.core.truth_(and__3508__auto__))
{return !(cljs.core.empty_QMARK_.call(null,cljs.core.name.call(null,class$)));
} else
{return and__3508__auto__;
}
})()))
{return elem.classList.remove(cljs.core.name.call(null,class$));
} else
{return null;
}
});
lt.util.dom.has_class_QMARK_ = (function has_class_QMARK_(elem,class$){if(cljs.core.truth_((function (){var and__3508__auto__ = elem;if(cljs.core.truth_(and__3508__auto__))
{return !(cljs.core.empty_QMARK_.call(null,cljs.core.name.call(null,class$)));
} else
{return and__3508__auto__;
}
})()))
{return elem.classList.contains(cljs.core.name.call(null,class$));
} else
{return null;
}
});
lt.util.dom.toggle_class = (function toggle_class(elem,class$){if(cljs.core.truth_(lt.util.dom.has_class_QMARK_.call(null,elem,class$)))
{return lt.util.dom.remove_class.call(null,elem,class$);
} else
{return lt.util.dom.add_class.call(null,elem,class$);
}
});
lt.util.dom.set_css = (function set_css(elem,things){var seq__4979 = cljs.core.seq.call(null,things);var chunk__4980 = null;var count__4981 = 0;var i__4982 = 0;while(true){
if((i__4982 < count__4981))
{var vec__4983 = cljs.core._nth.call(null,chunk__4980,i__4982);var k = cljs.core.nth.call(null,vec__4983,0,null);var v = cljs.core.nth.call(null,vec__4983,1,null);(elem.style[cljs.core.name.call(null,k)] = (((v instanceof cljs.core.Keyword))?cljs.core.name.call(null,v):v));
{
var G__4985 = seq__4979;
var G__4986 = chunk__4980;
var G__4987 = count__4981;
var G__4988 = (i__4982 + 1);
seq__4979 = G__4985;
chunk__4980 = G__4986;
count__4981 = G__4987;
i__4982 = G__4988;
continue;
}
} else
{var temp__4092__auto__ = cljs.core.seq.call(null,seq__4979);if(temp__4092__auto__)
{var seq__4979__$1 = temp__4092__auto__;if(cljs.core.chunked_seq_QMARK_.call(null,seq__4979__$1))
{var c__4262__auto__ = cljs.core.chunk_first.call(null,seq__4979__$1);{
var G__4989 = cljs.core.chunk_rest.call(null,seq__4979__$1);
var G__4990 = c__4262__auto__;
var G__4991 = cljs.core.count.call(null,c__4262__auto__);
var G__4992 = 0;
seq__4979 = G__4989;
chunk__4980 = G__4990;
count__4981 = G__4991;
i__4982 = G__4992;
continue;
}
} else
{var vec__4984 = cljs.core.first.call(null,seq__4979__$1);var k = cljs.core.nth.call(null,vec__4984,0,null);var v = cljs.core.nth.call(null,vec__4984,1,null);(elem.style[cljs.core.name.call(null,k)] = (((v instanceof cljs.core.Keyword))?cljs.core.name.call(null,v):v));
{
var G__4993 = cljs.core.next.call(null,seq__4979__$1);
var G__4994 = null;
var G__4995 = 0;
var G__4996 = 0;
seq__4979 = G__4993;
chunk__4980 = G__4994;
count__4981 = G__4995;
i__4982 = G__4996;
continue;
}
}
} else
{return null;
}
}
break;
}
});
lt.util.dom.css = (function css(elem,things){var things__$1 = ((cljs.core._EQ_.call(null,Object,cljs.core.type.call(null,things)))?cljs.core.js__GT_clj.call(null,things):things);if(cljs.core.map_QMARK_.call(null,things__$1))
{return lt.util.dom.set_css.call(null,elem,things__$1);
} else
{return (elem.style[cljs.core.name.call(null,things__$1)]);
}
});
lt.util.dom.set_attr = (function set_attr(elem,things){var seq__5003 = cljs.core.seq.call(null,things);var chunk__5004 = null;var count__5005 = 0;var i__5006 = 0;while(true){
if((i__5006 < count__5005))
{var vec__5007 = cljs.core._nth.call(null,chunk__5004,i__5006);var k = cljs.core.nth.call(null,vec__5007,0,null);var v = cljs.core.nth.call(null,vec__5007,1,null);elem.setAttribute(cljs.core.name.call(null,k),(((v instanceof cljs.core.Keyword))?cljs.core.name.call(null,v):v));
{
var G__5009 = seq__5003;
var G__5010 = chunk__5004;
var G__5011 = count__5005;
var G__5012 = (i__5006 + 1);
seq__5003 = G__5009;
chunk__5004 = G__5010;
count__5005 = G__5011;
i__5006 = G__5012;
continue;
}
} else
{var temp__4092__auto__ = cljs.core.seq.call(null,seq__5003);if(temp__4092__auto__)
{var seq__5003__$1 = temp__4092__auto__;if(cljs.core.chunked_seq_QMARK_.call(null,seq__5003__$1))
{var c__4262__auto__ = cljs.core.chunk_first.call(null,seq__5003__$1);{
var G__5013 = cljs.core.chunk_rest.call(null,seq__5003__$1);
var G__5014 = c__4262__auto__;
var G__5015 = cljs.core.count.call(null,c__4262__auto__);
var G__5016 = 0;
seq__5003 = G__5013;
chunk__5004 = G__5014;
count__5005 = G__5015;
i__5006 = G__5016;
continue;
}
} else
{var vec__5008 = cljs.core.first.call(null,seq__5003__$1);var k = cljs.core.nth.call(null,vec__5008,0,null);var v = cljs.core.nth.call(null,vec__5008,1,null);elem.setAttribute(cljs.core.name.call(null,k),(((v instanceof cljs.core.Keyword))?cljs.core.name.call(null,v):v));
{
var G__5017 = cljs.core.next.call(null,seq__5003__$1);
var G__5018 = null;
var G__5019 = 0;
var G__5020 = 0;
seq__5003 = G__5017;
chunk__5004 = G__5018;
count__5005 = G__5019;
i__5006 = G__5020;
continue;
}
}
} else
{return null;
}
}
break;
}
});
lt.util.dom.attr = (function attr(elem,things){if(cljs.core.map_QMARK_.call(null,things))
{return lt.util.dom.set_attr.call(null,elem,things);
} else
{return elem.getAttribute(cljs.core.name.call(null,things));
}
});
lt.util.dom.parent = (function parent(elem){return elem.parentNode;
});
lt.util.dom.children = (function children(elem){return elem.children;
});
lt.util.dom.remove = (function remove(elem){var temp__4092__auto__ = lt.util.dom.parent.call(null,elem);if(cljs.core.truth_(temp__4092__auto__))
{var p = temp__4092__auto__;return p.removeChild(elem);
} else
{return null;
}
});
lt.util.dom.empty = (function empty(elem){return elem.innerHTML = "";
});
/**
* @param {...*} var_args
*/
lt.util.dom.val = (function() { 
var val__delegate = function (elem,p__5021){var vec__5023 = p__5021;var v = cljs.core.nth.call(null,vec__5023,0,null);if(cljs.core.not.call(null,v))
{return elem.value;
} else
{return elem.value = v;
}
};
var val = function (elem,var_args){
var p__5021 = null;if (arguments.length > 1) {
  p__5021 = cljs.core.array_seq(Array.prototype.slice.call(arguments, 1),0);} 
return val__delegate.call(this,elem,p__5021);};
val.cljs$lang$maxFixedArity = 1;
val.cljs$lang$applyTo = (function (arglist__5024){
var elem = cljs.core.first(arglist__5024);
var p__5021 = cljs.core.rest(arglist__5024);
return val__delegate(elem,p__5021);
});
val.cljs$core$IFn$_invoke$arity$variadic = val__delegate;
return val;
})()
;
lt.util.dom.prevent = (function prevent(e){return e.preventDefault();
});
lt.util.dom.stop_propagation = (function stop_propagation(e){return e.stopPropagation();
});
lt.util.dom.siblings = (function siblings(elem){return lt.util.dom.parent.call(null,elem).children;
});
lt.util.dom.parents = (function parents(elem,sel){var root = lt.util.dom.parent.call(null,lt.util.dom.$.call(null,new cljs.core.Keyword(null,"body","body",1016933652)));var p = lt.util.dom.parent.call(null,elem);while(true){
if(cljs.core.truth_((function (){var and__3508__auto__ = p;if(cljs.core.truth_(and__3508__auto__))
{return cljs.core.not_EQ_.call(null,p,root);
} else
{return and__3508__auto__;
}
})()))
{if(cljs.core.truth_(p.webkitMatchesSelector(cljs.core.name.call(null,sel))))
{return p;
} else
{{
var G__5025 = lt.util.dom.parent.call(null,p);
p = G__5025;
continue;
}
}
} else
{return null;
}
break;
}
});
lt.util.dom.next = (function next(elem){return elem.nextElementSibling;
});
lt.util.dom.before = (function before(elem,neue){return lt.util.dom.parent.call(null,elem).insertBefore(neue,elem);
});
lt.util.dom.after = (function after(elem,neue){var temp__4090__auto__ = lt.util.dom.next.call(null,elem);if(cljs.core.truth_(temp__4090__auto__))
{var n = temp__4090__auto__;return lt.util.dom.before.call(null,n,neue);
} else
{return lt.util.dom.append.call(null,lt.util.dom.parent.call(null,elem),neue);
}
});
lt.util.dom.replace_with = (function replace_with(orig,neue){var temp__4092__auto__ = lt.util.dom.parent.call(null,orig);if(cljs.core.truth_(temp__4092__auto__))
{var p = temp__4092__auto__;return p.replaceChild(neue,orig);
} else
{return null;
}
});
lt.util.dom.height = (function height(elem){return elem.clientHeight;
});
lt.util.dom.width = (function width(elem){return elem.clientWidth;
});
lt.util.dom.scroll_width = (function scroll_width(elem){return elem.scrollWidth;
});
lt.util.dom.offset_top = (function offset_top(elem){return elem.offsetTop;
});
/**
* @param {...*} var_args
*/
lt.util.dom.scroll_top = (function() { 
var scroll_top__delegate = function (elem,p__5026){var vec__5028 = p__5026;var v = cljs.core.nth.call(null,vec__5028,0,null);if(cljs.core.not.call(null,v))
{return elem.scrollTop;
} else
{return elem.scrollTop = v;
}
};
var scroll_top = function (elem,var_args){
var p__5026 = null;if (arguments.length > 1) {
  p__5026 = cljs.core.array_seq(Array.prototype.slice.call(arguments, 1),0);} 
return scroll_top__delegate.call(this,elem,p__5026);};
scroll_top.cljs$lang$maxFixedArity = 1;
scroll_top.cljs$lang$applyTo = (function (arglist__5029){
var elem = cljs.core.first(arglist__5029);
var p__5026 = cljs.core.rest(arglist__5029);
return scroll_top__delegate(elem,p__5026);
});
scroll_top.cljs$core$IFn$_invoke$arity$variadic = scroll_top__delegate;
return scroll_top;
})()
;
lt.util.dom.top = (function top(elem){return lt.util.dom.css.call(null,elem,new cljs.core.Keyword(null,"top","top",1014019271));
});
lt.util.dom.bottom = (function bottom(elem){return lt.util.dom.css.call(null,elem,new cljs.core.Keyword(null,"bottom","bottom",3925642653));
});
lt.util.dom.left = (function left(elem){return lt.util.dom.css.call(null,elem,new cljs.core.Keyword(null,"left","left",1017222009));
});
lt.util.dom.right = (function right(elem){return lt.util.dom.css.call(null,elem,new cljs.core.Keyword(null,"right","right",1122416014));
});
/**
* @param {...*} var_args
*/
lt.util.dom.html = (function() { 
var html__delegate = function (elem,p__5030){var vec__5032 = p__5030;var h = cljs.core.nth.call(null,vec__5032,0,null);if(cljs.core.not.call(null,h))
{return elem.innerHTML;
} else
{return elem.innerHTML = h;
}
};
var html = function (elem,var_args){
var p__5030 = null;if (arguments.length > 1) {
  p__5030 = cljs.core.array_seq(Array.prototype.slice.call(arguments, 1),0);} 
return html__delegate.call(this,elem,p__5030);};
html.cljs$lang$maxFixedArity = 1;
html.cljs$lang$applyTo = (function (arglist__5033){
var elem = cljs.core.first(arglist__5033);
var p__5030 = cljs.core.rest(arglist__5033);
return html__delegate(elem,p__5030);
});
html.cljs$core$IFn$_invoke$arity$variadic = html__delegate;
return html;
})()
;
lt.util.dom.__GT_ev = (function __GT_ev(ev){return [cljs.core.str(cljs.core.name.call(null,ev))].join('');
});
/**
* @param {...*} var_args
*/
lt.util.dom.trigger = (function() { 
var trigger__delegate = function (elem,ev,p__5034){var vec__5036 = p__5034;var opts = cljs.core.nth.call(null,vec__5036,0,null);var e = document.createEvent("HTMLEvents");e.initEvent(cljs.core.name.call(null,ev),true,true);
e.opts = opts;
return elem.dispatchEvent(e);
};
var trigger = function (elem,ev,var_args){
var p__5034 = null;if (arguments.length > 2) {
  p__5034 = cljs.core.array_seq(Array.prototype.slice.call(arguments, 2),0);} 
return trigger__delegate.call(this,elem,ev,p__5034);};
trigger.cljs$lang$maxFixedArity = 2;
trigger.cljs$lang$applyTo = (function (arglist__5037){
var elem = cljs.core.first(arglist__5037);
arglist__5037 = cljs.core.next(arglist__5037);
var ev = cljs.core.first(arglist__5037);
var p__5034 = cljs.core.rest(arglist__5037);
return trigger__delegate(elem,ev,p__5034);
});
trigger.cljs$core$IFn$_invoke$arity$variadic = trigger__delegate;
return trigger;
})()
;
lt.util.dom.on = (function on(elem,ev,cb){return elem.addEventListener(lt.util.dom.__GT_ev.call(null,ev),cb);
});
lt.util.dom.off = (function off(elem,ev,cb){return elem.removeEventListener(lt.util.dom.__GT_ev.call(null,ev),cb);
});
lt.util.dom.on_STAR_ = (function on_STAR_(elem,evs){var seq__5044 = cljs.core.seq.call(null,evs);var chunk__5045 = null;var count__5046 = 0;var i__5047 = 0;while(true){
if((i__5047 < count__5046))
{var vec__5048 = cljs.core._nth.call(null,chunk__5045,i__5047);var ev = cljs.core.nth.call(null,vec__5048,0,null);var cb = cljs.core.nth.call(null,vec__5048,1,null);elem.addEventListener(lt.util.dom.__GT_ev.call(null,ev),cb);
{
var G__5050 = seq__5044;
var G__5051 = chunk__5045;
var G__5052 = count__5046;
var G__5053 = (i__5047 + 1);
seq__5044 = G__5050;
chunk__5045 = G__5051;
count__5046 = G__5052;
i__5047 = G__5053;
continue;
}
} else
{var temp__4092__auto__ = cljs.core.seq.call(null,seq__5044);if(temp__4092__auto__)
{var seq__5044__$1 = temp__4092__auto__;if(cljs.core.chunked_seq_QMARK_.call(null,seq__5044__$1))
{var c__4262__auto__ = cljs.core.chunk_first.call(null,seq__5044__$1);{
var G__5054 = cljs.core.chunk_rest.call(null,seq__5044__$1);
var G__5055 = c__4262__auto__;
var G__5056 = cljs.core.count.call(null,c__4262__auto__);
var G__5057 = 0;
seq__5044 = G__5054;
chunk__5045 = G__5055;
count__5046 = G__5056;
i__5047 = G__5057;
continue;
}
} else
{var vec__5049 = cljs.core.first.call(null,seq__5044__$1);var ev = cljs.core.nth.call(null,vec__5049,0,null);var cb = cljs.core.nth.call(null,vec__5049,1,null);elem.addEventListener(lt.util.dom.__GT_ev.call(null,ev),cb);
{
var G__5058 = cljs.core.next.call(null,seq__5044__$1);
var G__5059 = null;
var G__5060 = 0;
var G__5061 = 0;
seq__5044 = G__5058;
chunk__5045 = G__5059;
count__5046 = G__5060;
i__5047 = G__5061;
continue;
}
}
} else
{return null;
}
}
break;
}
});
lt.util.dom.active_element = (function active_element(){return document.activeElement;
});
lt.util.dom.focus = (function focus(elem){return elem.focus();
});
lt.util.dom.blur = (function blur(elem){return elem.blur();
});
lt.util.dom.selection = (function selection(elem,start,stop,dir){return elem.setSelectionRange(start,stop,dir);
});
lt.util.dom.make = (function make(str){var d = document.createElement("div");lt.util.dom.html.call(null,d,str);
return lt.util.dom.children.call(null,d);
});
lt.util.dom.index = (function index(e){var p = lt.util.dom.parent.call(null,e);var c = (cljs.core.truth_(p)?lt.util.dom.children.call(null,p):[]);var len = c.length;if(cljs.core.not.call(null,p))
{return -1;
} else
{var i = 0;while(true){
if((i >= len))
{return null;
} else
{if(cljs.core._EQ_.call(null,(c[i]),e))
{return i;
} else
{{
var G__5062 = (i + 1);
i = G__5062;
continue;
}
}
}
break;
}
}
});
lt.util.dom.ready = (function ready(func){return lt.util.dom.on.call(null,document,new cljs.core.Keyword(null,"DOMContentLoaded","DOMContentLoaded",3783578446),func);
});
lt.util.dom.fragment = (function fragment(items){var frag = document.createDocumentFragment();var seq__5067_5071 = cljs.core.seq.call(null,items);var chunk__5068_5072 = null;var count__5069_5073 = 0;var i__5070_5074 = 0;while(true){
if((i__5070_5074 < count__5069_5073))
{var i_5075 = cljs.core._nth.call(null,chunk__5068_5072,i__5070_5074);frag.appendChild(i_5075);
{
var G__5076 = seq__5067_5071;
var G__5077 = chunk__5068_5072;
var G__5078 = count__5069_5073;
var G__5079 = (i__5070_5074 + 1);
seq__5067_5071 = G__5076;
chunk__5068_5072 = G__5077;
count__5069_5073 = G__5078;
i__5070_5074 = G__5079;
continue;
}
} else
{var temp__4092__auto___5080 = cljs.core.seq.call(null,seq__5067_5071);if(temp__4092__auto___5080)
{var seq__5067_5081__$1 = temp__4092__auto___5080;if(cljs.core.chunked_seq_QMARK_.call(null,seq__5067_5081__$1))
{var c__4262__auto___5082 = cljs.core.chunk_first.call(null,seq__5067_5081__$1);{
var G__5083 = cljs.core.chunk_rest.call(null,seq__5067_5081__$1);
var G__5084 = c__4262__auto___5082;
var G__5085 = cljs.core.count.call(null,c__4262__auto___5082);
var G__5086 = 0;
seq__5067_5071 = G__5083;
chunk__5068_5072 = G__5084;
count__5069_5073 = G__5085;
i__5070_5074 = G__5086;
continue;
}
} else
{var i_5087 = cljs.core.first.call(null,seq__5067_5081__$1);frag.appendChild(i_5087);
{
var G__5088 = cljs.core.next.call(null,seq__5067_5081__$1);
var G__5089 = null;
var G__5090 = 0;
var G__5091 = 0;
seq__5067_5071 = G__5088;
chunk__5068_5072 = G__5089;
count__5069_5073 = G__5090;
i__5070_5074 = G__5091;
continue;
}
}
} else
{}
}
break;
}
return frag;
});
